//+------------------------------------------------------------------+
//|                                                   Separation.mq4 |
//|                              Copyright  2008, Kevin Mikolajczyk |
//|                                        poolplayer635@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kevin Mikolajczyk"
#property link      "poolplayer635@hotmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Green
#property indicator_levelcolor Red
#property indicator_levelstyle STYLE_SOLID
#property indicator_minimum -30
#property indicator_maximum 30

extern int ShortPeriod = 6;
extern int ShortMode = 1;
extern int LongPeriod = 20;
extern int LongMode = 2;
extern double Points = 22;
extern bool Alerts = true;
//---- buffers
double IND[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,IND);
   SetLevelValue(0,Points);
   SetLevelValue(1,-Points);
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int limit;
   int counted_bars = IndicatorCounted();
     
   if(counted_bars<0)
   {
      return(-1);
   }
     
   if(counted_bars>0)
   {
      counted_bars -= 10;
   }
     
   limit = Bars - counted_bars;

   for(int i=0; i<limit; i++)
   {
      IND[i] = (iMA(NULL,0,ShortPeriod,0,ShortMode,0,i) - iMA(NULL,0,LongPeriod,0,LongMode,0,i)) * 1 / Point;
   }
   
   if (IsNewBar() && Alerts)
   {
      if (IND[1] > -Points && IND[2] < -Points)
      {
         Alert(Symbol(), " - Trend up signal");
      }
      else if (IND[1] < Points && IND[2] > Points)
      {
         Alert(Symbol(), " - Trend down signal");
      }
      else if (IND[1] > Points && IND[2] < Points)
      {
         Alert(Symbol(), " - Exit Buy");
      }
      else if (IND[1] < Points && IND[2] > Points)
      {
         Alert(Symbol(), " - Exit Sell");
      }
   }

   return(0);
}
bool IsNewBar()
{
   static datetime lastbar = 0;
   datetime curbar = Time[0];
   
   if (lastbar != curbar)
   {
      lastbar = curbar;
      return(true);
   }
   else
   {
      return(false);
   }
}
//+------------------------------------------------------------------+